﻿
interface I1 {
	public void m1();
	public void m2();
}

abstract class A {
	public abstract void f();
}

class B : A, I1 {
	public override void f() {
		Console.WriteLine("B.f()");
	}

	public void m1() {
		Console.WriteLine("B.m1()");
	}

	public virtual void m2() {
		Console.WriteLine("B.m2()");
	}
}

class C : B {
	public new void m1() {
		Console.WriteLine("C.m1()");
	}

	public override void m2() {
		Console.WriteLine("C.m2()");
	}
}

class D : B, I1 {
	public new void m1() {
		Console.WriteLine("D.m1()");
	}

	public override void m2() {
		Console.WriteLine("D.m2()");
	}
}

class Program {
	static void Main(string[] args) {
		// Error: Cannot create an instance of the abstract type or interface 'A'
		// A a = new A();

		Console.WriteLine("+++ B instance +++");
		Console.WriteLine(">>> Via B type variable:");
		B b = new B();
		b.f();
		b.m1();
		b.m2();

		Console.WriteLine(">>> Via A type variable:");
		A a = b;
		a.f();

		Console.WriteLine(">>> Via I1 type variable:");
		I1 i = b;
		i.m1();
		i.m2();

		Console.WriteLine();
		Console.WriteLine("+++ C instance +++");
		Console.WriteLine(">>> Via C type variable:");
		C c = new C();
		c.f();
		c.m1();
		c.m2();

		Console.WriteLine(">>> Via A type variable:");
		a = c;
		a.f();

		Console.WriteLine(">>> Via I1 type variable:");
		i = c;
		i.m1();
		i.m2();

		Console.WriteLine();
		Console.WriteLine("+++ D instance +++");
		Console.WriteLine(">>> Via D type variable:");
		D d = new D();
		d.f();
		d.m1();
		d.m2();

		Console.WriteLine(">>> Via A type variable:");
		a = d;
		a.f();

		Console.WriteLine(">>> Via I1 type variable:");
		i = d;
		i.m1();
		i.m2();
	}
}